﻿Imports Leap

Public Class LeapListener
    Inherits Listener
    Private fingersCount As Integer
    Public Overrides Sub OnConnect(ctlr As Controller)
        ctlr.EnableGesture(Gesture.GestureType.TYPECIRCLE)
    End Sub

    Public Overrides Sub OnFrame(ctlr As Controller)
        Dim currentFrame As Frame = ctlr.Frame
        If (Not currentFrame.Hands.Empty) Then

            Dim firstHand As Hand = currentFrame.Hands(0)
            Dim fingers As FingerList = firstHand.Fingers

            If (Not fingers.Empty) Then
                Dim gestures As GestureList = currentFrame.Gestures
                For Each gst As Gesture In gestures
                    If gst.Type = Gesture.GestureType.TYPECIRCLE Then
                        CircleAction(fingers, CircleEnum.Circle)
                    End If
                Next
            End If
        End If
    End Sub

    Public Delegate Sub CircleEvent(ByVal sd As CircleEnum)
    Public Event LeapCircle As CircleEvent

    Private Sub CircleAction(ByVal fingers As FingerList, ByVal sd As CircleEnum)
        fingersCount = fingers.Count
        If (fingersCount = 1) Then
            Select Case sd
                Case CircleEnum.Circle
                    RaiseEvent LeapCircle(CircleEnum.Circle)
                    Exit Select
            End Select
        End If
    End Sub
End Class


