﻿Imports Leap
Imports System.Windows.Ink
Class MainWindow
    Private leap As New Controller
    Private windowWidth As Double = 1000
    Private windowHeight As Double = 500
    Private touchIndicator As New DrawingAttributes
    Private touchPoint As StylusPoint
    Private x As Integer
    Private y As Integer


    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        AddHandler CompositionTarget.Rendering, AddressOf Update
        touchIndicator.Width = 30
        touchIndicator.Height = 30
        touchIndicator.StylusTip = StylusTip.Ellipse
    End Sub

    Private Sub Update(sender As Object, e As EventArgs)
        paintCanvas.Strokes.Clear()
        windowWidth = Me.Width
        windowHeight = Me.Height

        Dim frame As Leap.Frame = leap.Frame
        Dim interactionBox As InteractionBox = leap.Frame.InteractionBox
        For Each Pointable As Pointable In leap.Frame.Pointables
            Dim normalizedPosition As Leap.Vector = interactionBox.NormalizePoint(Pointable.StabilizedTipPosition)
            Dim tx As Double = normalizedPosition.x * windowWidth
            Dim ty As Double = windowHeight - normalizedPosition.y * windowHeight
            touchPoint = New StylusPoint(tx, ty)

            Dim tips As New StylusPointCollection(New StylusPoint() {touchPoint})
            Dim touchStroke As New Stroke(tips, touchIndicator)
            paintCanvas.Strokes.Add(touchStroke)

            If Pointable.TouchDistance > 0 AndAlso Pointable.TouchZone <> Global.Leap.Pointable.Zone.ZONENONE Then
                touchIndicator.Color = Colors.Navy
                x = touchPoint.X
                y = touchPoint.Y
                Index = 0
            ElseIf Pointable.TouchDistance <= 0 Then
                touchIndicator.Color = Colors.Red
                If x > Image1.GetValue(Canvas.LeftProperty) And x < Image1.GetValue(Canvas.LeftProperty) + Image1.Width AndAlso y > Image1.GetValue(Canvas.TopProperty) And y < Image1.GetValue(Canvas.TopProperty) + Image1.Height Then
                    Index = 1
                End If

                If x > Image2.GetValue(Canvas.LeftProperty) And x < Image2.GetValue(Canvas.LeftProperty) + Image2.Width AndAlso y > Image2.GetValue(Canvas.TopProperty) And y < Image2.GetValue(Canvas.TopProperty) + Image2.Height Then
                    Index = 2
                End If
                'タッチ対象外
            Else
                touchIndicator.Color = Colors.Gold
                Index = 0
            End If
        Next
    End Sub
End Class

